package pl.net.linux.krzak.kchat.util;

import java.util.Vector;
import java.awt.*;
import java.awt.event.*;

public class kChatTextArea extends Component implements AdjustmentListener {
    private final int MaxLines = 1000;
    private final int ACCEPT = 0;
    private final int IGNORE = 1;
    private int pozX = 10;
    private int Rows;
    private int Width = 200;
    private int startAt = 0;
    private int messagesCount = 0;
    private boolean pressedM = false;
    private Graphics buforGraf;
    private Image bufor;
    private Dimension rozmiarBuf;
    private MessagesClass messages[] = new MessagesClass[MaxLines];
    private kScrollbar scroll;
    private Vector sensitiveRectangles = new Vector();
    private boolean pressed = false; // true if the button is detented.
    private boolean over    = false; // true if the button is detented.
    private MouseEvent me = null;
    private ClickListener clickListener = null;


    /** 
	Create object with default Width=200 and Rows=2
    */
    public kChatTextArea() {
 this(200,2); }

    /** 
	@param _Width Initial width of component
	@param _Rows  Initial count of rows
    */
    public kChatTextArea(int _Width, int _Rows) {
	this.Width = _Width;
	this.Rows = _Rows;
	for (int i=0;i<MaxLines;i++) { messages[i]=null; }
    }
    
    
    /**
     to trzeba !!! poprawic, nie jest zbyt wydajne, ale chce mi sie spac i dziala.
    */
    public void removeMessage(int nr) {
	messages[nr] = null;

	MessagesClass messagestmp[] = new MessagesClass[MaxLines];
	for (int i=0;i<MaxLines;i++) messagestmp[i]=null;
	
	int j = 0;
	for (int i=0;i<messagesCount;i++) 
	    if (messages[i] != null) { 
		messagestmp[j] = messages[i]; 
		messagestmp[j].nr = j;
		j++; 
	    }
	
	for (int i=0;i<MaxLines;i++) messages[i]=messagestmp[i];
	
	messagesCount--;
    }
    
    /**	
	Add ClickListener
	@see kChatTextArea#removeClickListener
    */
    public void addClickListener(ClickListener cl) { 
	clickListener = cl; 
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

    /**	
	Remove ClickListener
	@see kChatTextArea#addClickListener
    */
    public void removeClickListener() { 
	clickListener = null; 
	disableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

    public void addScroll(kScrollbar sc) {
	scroll = sc;
	scroll.addAdjustmentListener(this);
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	    startAt = e.getValue();
	    this.paint(this.getGraphics());
    }
    
    public int getRows() { return Rows; }
    public int getOffset() { return pozX; }
    public void  setOffset(int off) { pozX = off; }

    /**
	Append text with specified colour into text area
	@param text Text to append
	@param color Text colour (ex. #1c1c1c)
	@see kChatTextArea#stringToColor
    */
    public synchronized void appendText(String text, String color) {
    /* if end of messages[]
 */
    if ((text == null) || (color == null)) return;
    text.trim();
    if (text.length()<=0) return;
    if (color.length()<=0) return;
    
    try {
    
    if (messagesCount>=messages.length) {
	messagesCount--;
	for (int i=0;i<messages.length;i++) {
	    if ((i+1)<messages.length)  { 
			    MessagesClass old = messages[i+1];
			    messages[i] = old;
			    }
	    }
	}
    messages[messagesCount] = new MessagesClass();
    messages[messagesCount].text = text;
    messages[messagesCount].color =
 stringToColor(color);
    messages[messagesCount].colortxt =
color;
    messages[messagesCount].nr = messagesCount;

    FontMetrics fm = this.getGraphics().getFontMetrics(getFont());

    if ((fm.stringWidth(text) + fm.getMaxAdvance())>(getSize().width-pozX)) {
	int w = 0; int j=0; int i=0;
	for (i=0; i<text.length();i++) {
		w = w + fm.charWidth(text.charAt(i));
		if ((w+fm.getMaxAdvance())>(getSize().width-pozX)) {
		    /* semi-intelligent word-wrapping
 */
		    int oldi = i;
		    while (((i-1)>0) && (text.charAt(i-1) != ' ') && (i>j)) i--;
		    if ((i<1) || ((i-1)<j)) i = oldi;
		    messages[messagesCount].linesV.addElement(text.substring(j,i-1));
		    w = 0; j=i;
		}
	}
	messages[messagesCount].linesV.addElement(text.substring(j-1,i));
    } else  {
    messages[messagesCount].linesV.addElement(text);
    }

   messagesCount++;
   this.paint(this.getGraphics());
   } 
   catch (StringIndexOutOfBoundsException e) {} 
   }


   public synchronized void update(Graphics g) {
   if (Width<=0) return;
   int pozY = 0;
   sensitiveRectangles.removeAllElements();
   FontMetrics fm = getFontMetrics(getFont());
   this.Rows = (getSize().height / fm.getHeight());
   
    if ((buforGraf == null)  || (getSize().width != rozmiarBuf.width)  || (getSize().height != rozmiarBuf.height)) {
	rozmiarBuf = getSize();
	bufor = createImage(getSize().width,getSize().height);
	buforGraf = bufor.getGraphics();
	}

    buforGraf.setFont(getFont());
    buforGraf.setColor(getBackground());
    buforGraf.fillRect(0, 0, getSize().width, getSize().height);

    int fontH = fm.getHeight();

    /* paint "len" last lines, start at "startAt", end at "endAt"
 */
    pozY = (fontH * Rows) - (fm.getMaxAscent()/2) + 1;
    int line=0;
    int endAt=startAt+Rows;
    
    for(int i=(messagesCount);i>=0;i--) {
     boolean lineok = false;
     if (messages[i] != null) {
        messages[i].rectangle.x = pozX;
	messages[i].rectangle.y = pozY;
	buforGraf.setColor(messages[i].color);
	for (int l=(messages[i].linesV.size()-1);l>=0;l--) {
	    if ((line) >= (Rows+startAt)) break;
	    if ((line>=startAt) && (line<=endAt)) {
		buforGraf.drawString((String)messages[i].linesV.elementAt(l),pozX,pozY);
		pozY=pozY-fontH;
		lineok = true;
		}
	    line++;
	    }
	if ((line-1) >= (Rows+startAt)) break;
	if (lineok) {
	    messages[i].rectangle.setSize(getSize().width,messages[i].rectangle.y-pozY);
	    messages[i].rectangle.y = messages[i].rectangle.y - messages[i].rectangle.height ;
	    sensitiveRectangles.addElement(messages[i]);
	}
      }
     if (scroll != null) { 
	    int linesall = 0;
	    for (int p=0;p<messagesCount;p++) { 
		if (messages[p] != null)
		    linesall = linesall + messages[p].linesV.size(); 
		}
	    scroll.setMaximum(linesall-Rows); 
	}
    }

    MessagesClass msgtmp;
    for (int i=0;i<sensitiveRectangles.size();i++) {
      msgtmp = (MessagesClass)sensitiveRectangles.elementAt(i);
      if (clickListener != null) { 
        buforGraf.setColor(Color.red);
    	buforGraf.drawRoundRect(msgtmp.rectangle.x-pozX, msgtmp.rectangle.y, 10, msgtmp.rectangle.height,3,3); 
	}
      if ((clickListener != null) && pressed && (me != null) && insideRectangle(msgtmp.rectangle,me.getPoint(),IGNORE)) clickListener.selectedItem(msgtmp,IGNORE);
      if (pressed && (me != null) && insideRectangle(msgtmp.rectangle,me.getPoint(),ACCEPT)) {
	buforGraf.setColor(Color.black);
	buforGraf.drawRect(msgtmp.rectangle.x, msgtmp.rectangle.y, msgtmp.rectangle.width, msgtmp.rectangle.height); 
	if (clickListener != null) clickListener.selectedItem(msgtmp,ACCEPT);
	}
      }

    g.drawImage(bufor, 0, 0, this);
    }


    public void paint(Graphics g) { update(g); }
    
    /**
	Convert string color represetation into proper object
	@param color Color value like #1c1c1c
    */
    public Color stringToColor(String color)
 {
 return new Color(1).decode(color); }
    
    public Dimension getMinimumSize() { return new Dimension(100, 50); }
    
    public Dimension getPreferredSize() {
	FontMetrics fm = getFontMetrics(super.getFont());
        int W = Width;
        int H = (fm.getHeight() * Rows);
        return new Dimension(W,H);
    }

   private boolean insideRectangle(Rectangle rect, Point point, int what) {
	if (what == ACCEPT) {
	    return ( (point.x > rect.x) && 
	     (point.x < (rect.x+rect.width)) && 
	     (point.y > rect.y) && 
	     (point.y < (rect.y + rect.height)) );
	    }
	if (what == IGNORE) {
	    return ( (point.x > rect.x-pozX) && 
	     (point.x < (rect.x+10)) && 
	     (point.y > rect.y) && 
	     (point.y < (rect.y + rect.height)) );
	}
	return false;
   }

   public void processMouseEvent(MouseEvent e) {
       me = e;
       switch(e.getID()) {
          case MouseEvent.MOUSE_PRESSED:
	    // render myself inverted....
	    pressed = true;

	    this.paint(this.getGraphics());
	    break;
          case MouseEvent.MOUSE_RELEASED:
//	    if(actionListener != null) {
//	       actionListener.actionPerformed(new ActionEvent(
//		   this, ActionEvent.ACTION_PERFORMED, actionCommand));
//	    }
	    // render myself normal again
	    if(pressed == true) {
		pressed = false;


		this.paint(this.getGraphics());
	    }
	    break;
          case MouseEvent.MOUSE_ENTERED:
	    if (over == false) {
		over = true;
		this.paint(this.getGraphics());
		}
	    break;
          case MouseEvent.MOUSE_EXITED:
	    if (over == true) { 
		over = false;
		
		this.paint(this.getGraphics());
	    }
	    if(pressed == true) {
		pressed = false;
		this.paint(this.getGraphics());
	    }
	    break;
       }
       super.processMouseEvent(e);
   }
    

}
